#ifndef _IAPTESTAPP_H_
#define _IAPTESTAPP_H_

#include <FApp.h>
#include <FBase.h>
#include <FSystem.h>
#include <FUi.h>

/**
 * [IapTestAppApp] application must inherit from Application class
 * which provides basic features necessary to define an application.
 */
class IapTestAppApp: public Tizen::App::Application
{
public:

    /**
     * [IapTestApp] application must have a factory method that creates an instance of itself.
     */
    static Tizen::App::Application* CreateInstance(void);

public:
    IapTestAppApp(void);

    ~IapTestAppApp(void);

public:

    // Called when the application is initializing.
    bool OnAppInitializing(Tizen::App::AppRegistry& appRegistry);

    // Called when the application is terminating.
    bool OnAppTerminating(Tizen::App::AppRegistry& appRegistry, bool forcedTermination = false);

    // Called when the application's frame moves to the top of the screen.
    void OnForeground(void);

    // Called when this application's frame is moved from top of the screen to the background.
    void OnBackground(void);

    // Called when the system memory is not sufficient to run the application any further.
    void OnLowMemory(void);

    // Called when the battery level changes.
    void OnBatteryLevelChanged(Tizen::System::BatteryLevel batteryLevel);

};

#endif // _IAPTESTAPP_H_
