#include "ui/SampleNativeFrame.h"
#include "ui/SampleNativeFormFactory.h"
#include "ui/SampleNativeSceneConsts.h"

using namespace Tizen::Base;
using namespace Tizen::Ui;
using namespace Tizen::Ui::Controls;
using namespace Tizen::Ui::Scenes;

SampleNativeFrame::SampleNativeFrame(void) {
}

SampleNativeFrame::~SampleNativeFrame(void) {
}

result SampleNativeFrame::OnInitializing(void) {
    static const wchar_t* PANEL_BLANK = L"";

    // Prepare Scene management.
    SceneManager* pSceneManager = SceneManager::GetInstance();
    static SampleNativeFormFactory formFactory;
    pSceneManager->RegisterFormFactory(formFactory);

    // Register all scenes
    result r = pSceneManager->RegisterScene(SCENE_MAIN, FORM_MAIN, PANEL_BLANK);
    r = pSceneManager->RegisterScene(SCENE_CONFIG, FORM_CONFIG, PANEL_BLANK);

    // Go to the scene.
    r = pSceneManager->GoForward(ForwardSceneTransition(SCENE_CONFIG));
    return r;
}

result SampleNativeFrame::OnTerminating(void) {
    result r = E_SUCCESS;
    return r;
}
